#ifndef _EYD_BITUNCOMPRESSOR_RLE2_HH
#define _EYD_BITUNCOMPRESSOR_RLE2_HH

#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <exception>

#include "eyd_bitgroup.hh"

#include "eyd_global.hh"
#include "eyd_iface.hh"


namespace EydLib {

	class BitUncompressorRle2 {
		private:
			BitGroup _wrk_grp;
			int _last_count;
			int _wrk_pos;
			int _group_size;
			std::list<BitGroup> _uncompressed;
			bool _first_group;

			void appendBit(bool bit);
		public:
			BitUncompressorRle2::BitUncompressorRle2(int size);

			void clear();
			void append(BitGroup bg);
			std::list<BitGroup> flush();
			bool hasContent();

			void flushRleData();
			void flushRawData();

	};
}

#endif
